---
title: 'XRSession: select event'
slug: Web/API/XRSession/select_event
tags:
  - API
  - AR
  - Input Source
  - Inputs
  - Mixed
  - Reality
  - Reference
  - Select
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceEvent
  - augmented
  - controllers
  - events
  - target
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p><span class="seoSummary">The WebXR event <code><strong>select</strong></code> is sent to an {{domxref("XRSession")}} when one of the session's input sources has completed a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_actions">primary action</a>.</span> Examples of comon kinds of primary action are users pressing triggers or buttons, tapping a touchpad, speaking a command, or performing a recognizable gesture when using a video tracking system or handheld controller with an accelerometer.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("XRInputSourceEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("XRSession.onselect", "onselect")}}</td>
  </tr>
 </tbody>
</table>

<p>For details on how the {{domxref("XRSession.selectstart_event", "selectstart")}}, {{domxref("XRSession.select_event", "select")}}, and {{domxref("XRSession.selectend_event", "selectend")}} events work, and how you should react to them, see {{SectionOnPage("/en-US/docs/Web/API/WebXR_Device_API/Inputs", "Primary actions")}}.</p>

<h2 id="Examples">Examples</h2>

<p>The following example uses {{domxref("EventTarget.addEventListener", "addEventListener()")}} to set up a handler for the <code>select</code> event. The handler fetches the pose representing the target ray for <code>tracked-pointer</code> inputs and sends the pose's transform to a function called <code>myHandleSelectWithRay()</code>.</p>

<pre class="brush: js">xrSession.addEventListener("select", event =&gt; {
  if (event.inputSource.targetRayMode == "tracked-pointer") {
    let targetRayPose = event.frame.getPose(event.inputSource.targetRaySpace,
                              myRefSpace);
    if (targetRayPose) {
      myHandleSelectWithRay(targetRayPose.transform);
    }
  }
});
</pre>

<p>You can of course also set up a handler for <code>select</code> events by setting the {{domxref("XRSession")}} object's {{domxref("XRSession.onselect", "onselect")}} event handler property to a function that handles the event:</p>

<pre class="brush: js">xrSession.onselect = event =&gt; {
  if (event.inputSource.targetRayMode == "tracked-pointer") {
    let targetRayPose = event.frame.getPose(event.inputSource.targetRaySpace,
                              myRefSpace);
    if (targetRayPose) {
      myHandleSelectWithRay(targetRayPose.transform);
    }
  }
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#eventdef-xrsession-select","select event")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.select_event")}}</div>
